<?php

namespace DAL;

use metier\Flux;
use PDO;

class FluxGateway
{
    private Connection $con;

    public function __construct(Connection $con){
        $this->con = $con;
    }

    public function addFlux($flux){
        try{
            $query = 'INSERT INTO Flux VALUES (:flux);';
            $this->con->executeQuery($query, array(':flux' => array($flux->getFlux(), PDO::PARAM_STR)));
        }catch (\PDOException $e){
            throw new \Exception("PDO error");
        }
    }

    public function removeFlux($flux){
        try{
            $query = 'DELETE FROM Flux WHERE flux = :flux;';
            $this->con->executeQuery($query, array(':flux' => array($flux->getFlux(), PDO::PARAM_STR)));
        }catch (\PDOException $e){
            throw new \Exception("PDO error");
        }
    }

    public function findAllFlux(){
        try{
            $query = 'SELECT * FROM Flux;';
            $this->con->executeQuery($query);
            return $this->con->getResults();
        }catch (\PDOException $e){
            throw new \Exception("PDO error");
        }
    }

    public function findFlux(Flux $flux){
        return $this->findFluxBySrc($flux->getFlux());
    }

    public function findFluxBySrc(string $flux){
        try{
            $query = 'SELECT * FROM Flux WHERE flux = :flux;';
            $this->con->executeQuery($query, array(':flux' => array($flux, PDO::PARAM_STR)));
            return $this->con->getResults();
        }catch (\PDOException $e){
            throw new \Exception("PDO error");
        }
    }
}